/***********************************************************/
#define mp3 Serial3 

#define LED1_PIN 2
#define LED2_PIN 3
#define ARDUINO_RX 5  //connect to TX of the module
#define ARDUINO_TX 6  //connect to RX of the module
#define SERVO_PIN 7
#define LIGHT_SENZOR_PIN 8

#include "mp3serial.h"
#include <Servo.h>  

const int SERVO_START_POSITION = 90;
const int COUNT_OF_SONGS = 9;

Servo servoMotor;

boolean isDancing = false;

void setup() {
        
  mp3.begin(9600);
  delay(500);                                         
  sendCommand(CMD_SEL_DEV, DEV_TF);  
  delay(200);

  servoMotor.attach( SERVO_PIN );
  servoMotor.write( SERVO_START_POSITION ); 

  pinMode(LED1_PIN, OUTPUT); 
  pinMode(LED2_PIN, OUTPUT); 
    
  randomSeed(analogRead(6));  // unused unalog pin 
}

void loop() {
 
  if( !digitalRead(  LIGHT_SENZOR_PIN )){    
    playSong();
    lightUp();       
    isDancing = true;
  }

  if( isDancing ){
    letDance();    
  }

  // Check for the answer.
  if (mp3.available()){ 

    // Song just ended    
    if( findText( "Completed play", decodeMP3Answer()) != -1 ){
      isDancing = false;      
      lightDown();    
      servoMotor.write( SERVO_START_POSITION ); 
    }     
  }  
}

void playSong(){
  sendCommand(CMD_PLAY_W_VOL, 0X0F00 + getRandomSongNumber() );
}

void letDance(){
  servoMotor.write( random(0, 180) );
  delay(500);
}

void lightUp(){
  digitalWrite(LED1_PIN, HIGH); 
  digitalWrite(LED2_PIN, HIGH);   
}

void lightDown(){
  digitalWrite(LED1_PIN, LOW); 
  digitalWrite(LED2_PIN, LOW);
}

//-- UTILS -----------------
long getRandomSongNumber(){
  return random(1, COUNT_OF_SONGS + 1);  
}

int findText(String needle, String haystack) {
  int foundpos = -1;
  for (int i = 0; i <= haystack.length() - needle.length(); i++) {
    if (haystack.substring(i,needle.length()+i) == needle) {
      foundpos = i;
    }
  }
  
  return foundpos;
}




  
 
 



